diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/mobility/bindings/modulegen__gcc_LP64.py ns-3.32/src/mobility/bindings/modulegen__gcc_LP64.py
--- ns-3.31/src/mobility/bindings/modulegen__gcc_LP64.py	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/mobility/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
@@ -5998,7 +6101,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::MobilityModel const >', 'arg0')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Const_ns3Address___amp___Ns3NetDevicePacketType_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6020,7 +6123,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3'), param('ns3::Address const &', 'arg4'), param('ns3::NetDevice::PacketType', 'arg5')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -6042,7 +6145,7 @@
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0')], 
-                   custom_name='__call__', is_virtual=True, is_pure_virtual=True)
+                   is_virtual=True, custom_name='__call__', is_pure_virtual=True)
     return
 
 def register_Ns3ConstantAccelerationMobilityModel_methods(root_module, cls):
@@ -6063,12 +6166,12 @@
     cls.add_method('DoGetPosition', 
                    'ns3::Vector', 
                    [], 
-                   is_virtual=True, visibility='private', is_const=True)
+                   is_virtual=True, is_const=True, visibility='private')
     ## constant-acceleration-mobility-model.h (module 'mobility'): ns3::Vector ns3::ConstantAccelerationMobilityModel::DoGetVelocity() const [member function]
     cls.add_method('DoGetVelocity', 
                    'ns3::Vector', 
                    [], 
-                   is_virtual=True, visibility='private', is_const=True)
+                   is_virtual=True, is_const=True, visibility='private')
     ## constant-acceleration-mobility-model.h (module 'mobility'): void ns3::ConstantAccelerationMobilityModel::DoSetPosition(ns3::Vector const & position) [member function]
     cls.add_method('DoSetPosition', 
                    'void', 
@@ -6090,12 +6193,12 @@
     cls.add_method('DoGetPosition', 
                    'ns3::Vector', 
                    [], 
-                   is_virtual=True, visibility='private', is_const=True)
+                   is_virtual=True, is_const=True, visibility='private')
     ## constant-position-mobility-model.h (module 'mobility'): ns3::Vector ns3::ConstantPositionMobilityModel::DoGetVelocity() const [member function]
     cls.add_method('DoGetVelocity', 
                    'ns3::Vector', 
                    [], 
-                   is_virtual=True, visibility='private', is_const=True)
+                   is_virtual=True, is_const=True, visibility='private')
     ## constant-position-mobility-model.h (module 'mobility'): void ns3::ConstantPositionMobilityModel::DoSetPosition(ns3::Vector const & position) [member function]
     cls.add_method('DoSetPosition', 
                    'void', 
@@ -6121,12 +6224,12 @@
     cls.add_method('DoGetPosition', 
                    'ns3::Vector', 
                    [], 
-                   is_virtual=True, visibility='private', is_const=True)
+                   is_virtual=True, is_const=True, visibility='private')
     ## constant-velocity-mobility-model.h (module 'mobility'): ns3::Vector ns3::ConstantVelocityMobilityModel::DoGetVelocity() const [member function]
     cls.add_method('DoGetVelocity', 
                    'ns3::Vector', 
                    [], 
-                   is_virtual=True, visibility='private', is_const=True)
+                   is_virtual=True, is_const=True, visibility='private')
     ## constant-velocity-mobility-model.h (module 'mobility'): void ns3::ConstantVelocityMobilityModel::DoSetPosition(ns3::Vector const & position) [member function]
     cls.add_method('DoSetPosition', 
                    'void', 
@@ -6158,12 +6261,12 @@
     cls.add_method('DoGetPosition', 
                    'ns3::Vector', 
                    [], 
-                   is_virtual=True, visibility='private', is_const=True)
+                   is_virtual=True, is_const=True, visibility='private')
     ## gauss-markov-mobility-model.h (module 'mobility'): ns3::Vector ns3::GaussMarkovMobilityModel::DoGetVelocity() const [member function]
     cls.add_method('DoGetVelocity', 
                    'ns3::Vector', 
                    [], 
-                   is_virtual=True, visibility='private', is_const=True)
+                   is_virtual=True, is_const=True, visibility='private')
     ## gauss-markov-mobility-model.h (module 'mobility'): void ns3::GaussMarkovMobilityModel::DoSetPosition(ns3::Vector const & position) [member function]
     cls.add_method('DoSetPosition', 
                    'void', 
@@ -6203,12 +6306,12 @@
     cls.add_method('DoGetPosition', 
                    'ns3::Vector', 
                    [], 
-                   is_virtual=True, visibility='private', is_const=True)
+                   is_virtual=True, is_const=True, visibility='private')
     ## hierarchical-mobility-model.h (module 'mobility'): ns3::Vector ns3::HierarchicalMobilityModel::DoGetVelocity() const [member function]
     cls.add_method('DoGetVelocity', 
                    'ns3::Vector', 
                    [], 
-                   is_virtual=True, visibility='private', is_const=True)
+                   is_virtual=True, is_const=True, visibility='private')
     ## hierarchical-mobility-model.h (module 'mobility'): void ns3::HierarchicalMobilityModel::DoSetPosition(ns3::Vector const & position) [member function]
     cls.add_method('DoSetPosition', 
                    'void', 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/mobility/model/geographic-positions.cc ns-3.32/src/mobility/model/geographic-positions.cc
--- ns-3.31/src/mobility/model/geographic-positions.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/mobility/model/geographic-positions.cc	2020-10-06 15:35:43.000000000 -0700
@@ -27,7 +27,7 @@
 namespace ns3 {
 
 /// Earth's radius in meters if modeled as a perfect sphere
-static const double EARTH_RADIUS = 6371e3; 
+static constexpr double EARTH_RADIUS = 6371e3; 
 
 /**
  * GRS80 and WGS84 sources
@@ -41,13 +41,19 @@
  */
 
 /// Earth's semi-major axis in meters as defined by both GRS80 and WGS84
-static const double EARTH_SEMIMAJOR_AXIS = 6378137;
+static constexpr double EARTH_SEMIMAJOR_AXIS = 6378137;
 
 /// Earth's first eccentricity as defined by GRS80
-static const double EARTH_GRS80_ECCENTRICITY = 0.0818191910428158;
+static constexpr double EARTH_GRS80_ECCENTRICITY = 0.0818191910428158;
 
 /// Earth's first eccentricity as defined by WGS84
-static const double EARTH_WGS84_ECCENTRICITY = 0.0818191908426215;
+static constexpr double EARTH_WGS84_ECCENTRICITY = 0.0818191908426215;
+
+/// Conversion factor: degrees to radians
+static constexpr double DEG2RAD = M_PI / 180.0;
+
+/// Conversion factor: radians to degrees
+static constexpr double RAD2DEG = 180.0 * M_1_PI;
 
 Vector
 GeographicPositions::GeographicToCartesianCoordinates (double latitude, 
@@ -56,8 +62,8 @@
                                                        EarthSpheroidType sphType)
 {
   NS_LOG_FUNCTION_NOARGS ();
-  double latitudeRadians = 0.01745329 * latitude;
-  double longitudeRadians = 0.01745329 * longitude;
+  double latitudeRadians = DEG2RAD * latitude;
+  double longitudeRadians = DEG2RAD * longitude;
   double a; // semi-major axis of earth
   double e; // first eccentricity of earth
   if (sphType == SPHERE)
@@ -85,6 +91,74 @@
   return cartesianCoordinates;
 }
 
+Vector
+GeographicPositions::CartesianToGeographicCoordinates (Vector pos, EarthSpheroidType sphType)
+{
+  NS_LOG_FUNCTION (pos << sphType);
+
+  double a; // semi-major axis of earth
+  double e; // first eccentricity of earth
+  if (sphType == SPHERE)
+    {
+      a = EARTH_RADIUS;
+      e = 0;
+    }
+  else if (sphType == GRS80)
+    {
+      a = EARTH_SEMIMAJOR_AXIS;
+      e = EARTH_GRS80_ECCENTRICITY;
+    }
+  else // if sphType == WGS84
+    {
+      a = EARTH_SEMIMAJOR_AXIS;
+      e = EARTH_WGS84_ECCENTRICITY;
+    }
+
+  Vector lla, tmp;
+  lla.y = atan2 (pos.y, pos.x); // longitude (rad), in +/- pi
+
+  double e2 = e * e;
+  // sqrt (pos.x^2 + pos.y^2)
+  double p = CalculateDistance (pos, {0, 0, pos.z});
+  lla.x = atan2 (pos.z, p * (1 - e2));  // init latitude (rad), in +/- pi
+
+  do
+    {
+      tmp = lla;
+      double N = a / sqrt (1 - e2 * sin (tmp.x) * sin (tmp.x));
+      double v = p / cos (tmp.x);
+      lla.z = v - N;  // altitude
+      lla.x = atan2 (pos.z, p * (1 - e2 * N / v));
+    }
+  // 1 m difference is approx 1 / 30 arc seconds = 9.26e-6 deg
+  while (fabs (lla.x - tmp.x) > 0.00000926 * DEG2RAD);
+
+  lla.x *= RAD2DEG;
+  lla.y *= RAD2DEG;
+
+  // canonicalize (latitude) x in [-90, 90] and (longitude) y in [-180, 180)
+  if (lla.x > 90.0)
+    {
+      lla.x = 180 - lla.x;
+      lla.y += lla.y < 0 ? 180 : -180;
+    }
+  else if (lla.x < -90.0)
+    {
+      lla.x = -180 - lla.x;
+      lla.y += lla.y < 0 ? 180 : -180;
+    }
+  if (lla.y == 180.0) lla.y = -180;
+
+  // make sure lat/lon in the right range to double check canonicalization
+  // and conversion routine
+  NS_ASSERT_MSG (-180.0 <= lla.y, "Conversion error: longitude too negative");
+  NS_ASSERT_MSG (180.0 > lla.y, "Conversion error: longitude too positive");
+  NS_ASSERT_MSG (-90.0 <= lla.x, "Conversion error: latitude too negative");
+  NS_ASSERT_MSG (90.0 >= lla.x, "Conversion error: latitude too positive");
+
+  return lla;
+}
+
 std::list<Vector>
 GeographicPositions::RandCartesianPointsAroundGeographicPoint (double originLatitude, 
                                                                double originLongitude, 
@@ -114,9 +188,9 @@
       maxAltitude = 0;
     }
 
-  double originLatitudeRadians = originLatitude * (M_PI / 180);
-  double originLongitudeRadians = originLongitude * (M_PI / 180);
-  double originColatitude = (M_PI / 2) - originLatitudeRadians;
+  double originLatitudeRadians = originLatitude * DEG2RAD;
+  double originLongitudeRadians = originLongitude * DEG2RAD;
+  double originColatitude = (M_PI_2) - originLatitudeRadians;
 
   double a = maxDistFromOrigin / EARTH_RADIUS; // maximum alpha allowed 
                                                // (arc length formula)
@@ -138,7 +212,7 @@
 
       // shift coordinate system from North Pole referred to origin point referred
       // reference: http://en.wikibooks.org/wiki/General_Astronomy/Coordinate_Systems
-      double theta = M_PI / 2 - alpha; // angle of elevation of new point wrt 
+      double theta = M_PI_2 - alpha;   // angle of elevation of new point wrt 
                                        // origin point (latitude in coordinate 
                                        // system referred to origin point)
       double randPointLatitude = asin(sin(theta)*cos(originColatitude) + 
@@ -147,12 +221,12 @@
       double intermedLong = asin((sin(randPointLatitude)*cos(originColatitude) - 
                             sin(theta)) / (cos(randPointLatitude)*sin(originColatitude))); 
                             // right ascension
-      intermedLong = intermedLong + M_PI / 2; // shift to longitude 0
+      intermedLong = intermedLong + M_PI_2; // shift to longitude 0
 
       //flip / mirror point if it has phi in quadrant II or III (wasn't 
       //resolved correctly by arcsin) across longitude 0
-      if (phi > (M_PI / 2) && phi <= ((3 * M_PI) / 2))
-      intermedLong = -intermedLong;
+      if (phi > (M_PI_2) && phi <= (3 * M_PI_2))
+        intermedLong = -intermedLong;
 
       // shift longitude to be referenced to origin
       double randPointLongitude = intermedLong + originLongitudeRadians; 
@@ -161,8 +235,8 @@
       double randAltitude = uniRand->GetValue (0, maxAltitude);
 
       Vector pointPosition = GeographicPositions::GeographicToCartesianCoordinates 
-                             (randPointLatitude * (180/M_PI), 
-                              randPointLongitude * (180/M_PI),
+                             (randPointLatitude * RAD2DEG, 
+                              randPointLongitude * RAD2DEG,
                               randAltitude,
                               SPHERE);
                               // convert coordinates 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/mobility/model/geographic-positions.h ns-3.32/src/mobility/model/geographic-positions.h
--- ns-3.31/src/mobility/model/geographic-positions.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/mobility/model/geographic-positions.h	2020-10-06 15:35:43.000000000 -0700
@@ -73,6 +73,27 @@
                                                   double altitude,
                                                   EarthSpheroidType sphType);
 
+/**
+ * Inverse of GeographicToCartesianCoordinates using [1]
+ *
+ * This function iteratively converts cartesian (ECEF) coordinates to
+ * geographic coordinates. The residual delta is 1 m, which is approximately
+ * 1 / 30 arc seconds or 9.26e-6 deg.
+ *
+ * @param pos a vector containing the Cartesian coordinates (x, y, z referenced
+ * in meters) of the point (origin (0, 0, 0) is center of earth)
+ * @param sphType earth spheroid model to use for conversion
+ *
+ * @return Vector position where x = latitude (deg), y = longitude (deg),
+ * z = altitude above the ellipsoid (m)
+ *
+ * [1] "Ellipsoidal and Cartesian Coordinates Conversion", Navipedia,
+ * European Space Agency, Jul 8, 2019.
+ * <https://gssc.esa.int/navipedia/index.php/Ellipsoidal_and_Cartesian_Coordinates_Conversion>
+ */
+static Vector CartesianToGeographicCoordinates (Vector pos,
+                                                EarthSpheroidType sphType);
+
   /**
    * Generates uniformly distributed random points (in ECEF Cartesian 
    * coordinates) within a given altitude above earth's surface centered around 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/mobility/test/geo-to-cartesian-test.cc ns-3.32/src/mobility/test/geo-to-cartesian-test.cc
--- ns-3.31/src/mobility/test/geo-to-cartesian-test.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/mobility/test/geo-to-cartesian-test.cc	2020-10-06 15:35:43.000000000 -0700
@@ -503,9 +503,9 @@
   /**
    * Constructor
    *
-   * \param latitude latitude
-   * \param longitude longitude
-   * \param altitude altitude
+   * \param latitude latitude (deg)
+   * \param longitude longitude (deg)
+   * \param altitude altitude (m)
    * \param sphType sphere type
    * \param i index
    */
@@ -518,11 +518,12 @@
 
 private:
   virtual void DoRun (void);
+
   /**
    * Name function
-   * \param latitude the latitude
-   * \param longitude the longitude
-   * \param altitude the altitude
+   * \param latitude the latitude (deg)
+   * \param longitude the longitude (deg)
+   * \param altitude the altitude (m)
    * \param sphType the sphere type
    * \returns the name string
    */
@@ -530,9 +531,9 @@
                            double longitude, 
                            double altitude,
                            GeographicPositions::EarthSpheroidType sphType);
-  double m_latitude; ///< latitude
-  double m_longitude; ///< longitude
-  double m_altitude; ///< altitude
+  double m_latitude; ///< latitude (deg)
+  double m_longitude; ///< longitude (deg)
+  double m_altitude; ///< altitude (m)
   GeographicPositions::EarthSpheroidType m_sphType; ///< spheroid type
   int m_i; ///< index
 };
@@ -544,10 +545,24 @@
                               GeographicPositions::EarthSpheroidType sphType)
 {
   std::ostringstream oss;
-  oss << "latitude = " << latitude << " degrees, "
-      << "longitude = " << longitude << " degrees, "
-      << "altitude = " << altitude << " meters, "
-      << "earth spheroid type = " << sphType;
+  oss << "Geo->Cart: "
+      << "LAT-LON-ALT-SPHEROID = " 
+      << latitude << " deg - "
+      << longitude << " deg - "
+      << altitude << " m - ";
+  switch (sphType)
+    {
+      case GeographicPositions::SPHERE:
+        oss  << "SPHERE";
+        break;
+      case GeographicPositions::GRS80:
+        oss << "GRS80";
+        break;
+      case GeographicPositions::WGS84:
+        oss << "WGS84";
+        break;
+    };
+
   return oss.str();
 }
 
@@ -636,6 +651,123 @@
  * \ingroup mobility-test
  * \ingroup tests
  *
+ * \brief Cartesian to Geo Test Case
+ *
+ * This test verifies the accuracy of the CartesianToGeographicCoordinates()
+ * method in the GeographicPositions class, which converts earth
+ * ECEF Cartesian coordinates to geographic/geodetic coordinates. To do so, it
+ * compares the values generated from the method and converted back to geographic
+ * coordinates.  Values are compared using 216 test cases for each of the three
+ * earth spheroid models.
+ */
+class CartesianToGeoTestCase : public TestCase
+{
+public:
+  /**
+   * Constructor
+   *
+   * \param latitude latitude (deg)
+   * \param longitude longitude (deg)
+   * \param altitude altitude (m)
+   * \param sphType sphere type
+   * \param i index
+   */
+  CartesianToGeoTestCase (double latitude,
+                          double longitude,
+                          double altitude,
+                          GeographicPositions::EarthSpheroidType sphType,
+                          int i);
+  virtual ~CartesianToGeoTestCase ();
+
+private:
+  virtual void DoRun (void);
+
+  /**
+   * Name function
+   * \param latitude the latitude (deg)
+   * \param longitude the longitude (deg)
+   * \param altitude the altitude (m)
+   * \param sphType the sphere type
+   * \returns the name string
+   */
+  static std::string Name (double latitude,
+                           double longitude,
+                           double altitude,
+                           GeographicPositions::EarthSpheroidType sphType);
+  double m_latitude; ///< latitude (deg)
+  double m_longitude; ///< longitude (deg)
+  double m_altitude; ///< altitude (m)
+  GeographicPositions::EarthSpheroidType m_sphType; ///< spheroid type
+};
+
+std::string
+CartesianToGeoTestCase::Name (double latitude,
+                              double longitude,
+                              double altitude,
+                              GeographicPositions::EarthSpheroidType sphType)
+{
+  std::ostringstream oss;
+  oss << "Cart->Geo: "
+      << "LAT-LON-ALT-SPHEROID = " 
+      << latitude << " deg - "
+      << longitude << " deg - "
+      << altitude << " m - ";
+  switch (sphType)
+    {
+      case GeographicPositions::SPHERE:
+        oss  << "SPHERE";
+        break;
+      case GeographicPositions::GRS80:
+        oss << "GRS80";
+        break;
+      case GeographicPositions::WGS84:
+        oss << "WGS84";
+        break;
+    };
+
+  return oss.str();
+}
+
+CartesianToGeoTestCase::CartesianToGeoTestCase (double latitude,
+                                                double longitude,
+                                                double altitude,
+                                                GeographicPositions::EarthSpheroidType sphType,
+                                                int i)
+  : TestCase (Name (latitude, longitude, altitude, sphType)),
+    m_latitude (latitude),
+    m_longitude (longitude),
+    m_altitude (altitude),
+    m_sphType (sphType)
+{
+}
+
+CartesianToGeoTestCase::~CartesianToGeoTestCase ()
+{
+}
+
+void
+CartesianToGeoTestCase::DoRun (void)
+{
+  Vector cart = GeographicPositions::GeographicToCartesianCoordinates (m_latitude,
+                                                                       m_longitude,
+                                                                       m_altitude,
+                                                                       m_sphType);
+  Vector geo = GeographicPositions::CartesianToGeographicCoordinates (cart, m_sphType);
+
+  // geographic coords are ambiguous due to angular wrapping, convert to
+  // rectangular for comparison
+  Vector geocart = GeographicPositions::GeographicToCartesianCoordinates (geo.x, geo.y, geo.z, m_sphType);
+
+  NS_TEST_ASSERT_MSG_LT_OR_EQ (CalculateDistance (cart, geocart),
+                               2.5, // minimum passing tolerance (m)
+                               "Double conversion out-of-tolerance: " <<
+                               geo << " <> " << Vector ({m_latitude, m_longitude, m_altitude}));
+}
+
+/**
+ * \ingroup mobility-test
+ * \ingroup tests
+ *
  * \brief Geo To Cartesian Test Suite
  */
 class GeoToCartesianTestSuite : public TestSuite
@@ -661,6 +793,12 @@
                                                        GeographicPositions::SPHERE,
                                                        i), 
                            TestCase::QUICK);
+              AddTestCase (new CartesianToGeoTestCase (latitude,
+                                                       longitude,
+                                                       altitude,
+                                                       GeographicPositions::SPHERE,
+                                                       i),
+                           TestCase::QUICK);
               ++i;
             }
         }
@@ -678,6 +816,12 @@
                                                        GeographicPositions::GRS80,
                                                        i), 
                            TestCase::QUICK);
+              AddTestCase (new CartesianToGeoTestCase (latitude,
+                                                       longitude,
+                                                       altitude,
+                                                       GeographicPositions::GRS80,
+                                                       i),
+                           TestCase::QUICK);
               ++i;
             }
         }
@@ -695,6 +839,12 @@
                                                        GeographicPositions::WGS84,
                                                        i), 
                            TestCase::QUICK);
+              AddTestCase (new CartesianToGeoTestCase (latitude,
+                                                       longitude,
+                                                       altitude,
+                                                       GeographicPositions::WGS84,
+                                                       i),
+                           TestCase::QUICK);
               ++i;
             }
         }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/mobility/test/mobility-trace-example.mob ns-3.32/src/mobility/test/mobility-trace-example.mob
--- ns-3.31/src/mobility/test/mobility-trace-example.mob	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/mobility/test/mobility-trace-example.mob	2020-10-06 15:35:43.000000000 -0700
@@ -1,18 +1,18 @@
-now=+0.0ns node=0 pos=1.000:1.000:0.000 vel=-0.293:-0.956:0.000
-now=+0.0ns node=1 pos=6.000:1.000:0.000 vel=0.844:-0.537:0.000
-now=+0.0ns node=2 pos=11.000:1.000:0.000 vel=0.875:-0.485:0.000
-now=+0.0ns node=3 pos=1.000:6.000:0.000 vel=0.574:-0.819:0.000
-now=+1046036669.0ns node=0 pos=0.693:0.000:0.000 vel=-0.293:0.956:0.000
-now=+1863851861.0ns node=1 pos=7.573:0.000:0.000 vel=0.844:0.537:0.000
-now=+2000000000.0ns node=2 pos=12.750:0.031:0.000 vel=-0.952:-0.305:0.000
-now=+2000000000.0ns node=3 pos=2.148:4.362:0.000 vel=-0.932:-0.362:0.000
-now=+2000000000.0ns node=0 pos=0.413:0.912:0.000 vel=-0.320:-0.947:0.000
-now=+2000000000.0ns node=1 pos=7.688:0.073:0.000 vel=-1.000:0.013:0.000
-now=+2101230083.0ns node=2 pos=12.653:0.000:0.000 vel=-0.952:0.305:0.000
-now=+2962748145.0ns node=0 pos=0.105:0.000:0.000 vel=-0.320:0.947:0.000
-now=+3289440024.0ns node=0 pos=0.000:0.309:0.000 vel=0.320:0.947:0.000
-now=+4000000000.0ns node=3 pos=0.284:3.638:0.000 vel=0.891:-0.455:0.000
-now=+4000000000.0ns node=1 pos=5.688:0.099:0.000 vel=0.923:0.384:0.000
-now=+4000000000.0ns node=2 pos=10.845:0.580:0.000 vel=0.256:0.967:0.000
-now=+4000000000.0ns node=0 pos=0.228:0.983:0.000 vel=-0.724:-0.690:0.000
-now=+4314385619.0ns node=0 pos=0.000:0.766:0.000 vel=0.724:-0.690:0.000
+now=+0ns node=0 pos=1.000:1.000:0.000 vel=-0.293:-0.956:0.000
+now=+0ns node=1 pos=6.000:1.000:0.000 vel=0.844:-0.537:0.000
+now=+0ns node=2 pos=11.000:1.000:0.000 vel=0.875:-0.485:0.000
+now=+0ns node=3 pos=1.000:6.000:0.000 vel=0.574:-0.819:0.000
+now=+1.04604e+09ns node=0 pos=0.693:0.000:0.000 vel=-0.293:0.956:0.000
+now=+1.86385e+09ns node=1 pos=7.573:0.000:0.000 vel=0.844:0.537:0.000
+now=+2e+09ns node=2 pos=12.750:0.031:0.000 vel=-0.952:-0.305:0.000
+now=+2e+09ns node=3 pos=2.148:4.362:0.000 vel=-0.932:-0.362:0.000
+now=+2e+09ns node=0 pos=0.413:0.912:0.000 vel=-0.320:-0.947:0.000
+now=+2e+09ns node=1 pos=7.688:0.073:0.000 vel=-1.000:0.013:0.000
+now=+2.10123e+09ns node=2 pos=12.653:0.000:0.000 vel=-0.952:0.305:0.000
+now=+2.96275e+09ns node=0 pos=0.105:0.000:0.000 vel=-0.320:0.947:0.000
+now=+3.28944e+09ns node=0 pos=0.000:0.309:0.000 vel=0.320:0.947:0.000
+now=+4e+09ns node=3 pos=0.284:3.638:0.000 vel=0.891:-0.455:0.000
+now=+4e+09ns node=1 pos=5.688:0.099:0.000 vel=0.923:0.384:0.000
+now=+4e+09ns node=2 pos=10.845:0.580:0.000 vel=0.256:0.967:0.000
+now=+4e+09ns node=0 pos=0.228:0.983:0.000 vel=-0.724:-0.690:0.000
+now=+4.31439e+09ns node=0 pos=0.000:0.766:0.000 vel=0.724:-0.690:0.000
